# Generated by Django 2.2.5 on 2020-06-19 12:22

import datetime
from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import django.utils.timezone


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Incustumer',
            fields=[
                ('in_id', models.AutoField(primary_key=True, serialize=False)),
                ('card_id', models.CharField(max_length=200, unique=True)),
                ('face_id', models.IntegerField(blank=True, max_length=200, null=True)),
                ('first_name', models.CharField(max_length=300)),
                ('last_name', models.CharField(max_length=300)),
                ('phone', models.CharField(max_length=20)),
                ('gender', models.CharField(max_length=300)),
                ('age', models.CharField(max_length=20)),
                ('email', models.EmailField(max_length=254, null=True, unique=True)),
                ('point', models.IntegerField()),
                ('career', models.CharField(max_length=300)),
            ],
        ),
        migrations.CreateModel(
            name='Product',
            fields=[
                ('Pid', models.AutoField(primary_key=True, serialize=False)),
                ('P_name', models.CharField(max_length=1000)),
                ('P_nameEng', models.CharField(max_length=1000)),
                ('price', models.CharField(max_length=300)),
                ('p_type', models.CharField(blank=True, choices=[('HOT', 'hot'), ('COLD', 'cold'), ('BLENDED', 'blended')], max_length=10, null=True)),
                ('created_at', models.DateTimeField(blank=True, default=datetime.datetime.now)),
            ],
        ),
        migrations.CreateModel(
            name='Profile',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('location', models.CharField(blank=True, max_length=30)),
                ('birthdate', models.DateField(blank=True, null=True)),
                ('role', models.PositiveSmallIntegerField(blank=True, choices=[(1, 'Supervisor'), (2, 'Employees')], null=True)),
                ('user', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='Order',
            fields=[
                ('Oid', models.AutoField(primary_key=True, serialize=False)),
                ('sum_Order', models.CharField(max_length=300)),
                ('created_at', models.DateTimeField(blank=True, default=datetime.datetime.now)),
                ('Emp', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
                ('product', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, to='Webcashier.Product')),
                ('user', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, to='Webcashier.Incustumer')),
            ],
        ),
        migrations.CreateModel(
            name='Employees',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('full_name', models.CharField(max_length=300)),
                ('dob', models.DateField(default=django.utils.timezone.now)),
                ('gen_der', models.CharField(max_length=300)),
                ('age', models.CharField(max_length=20)),
                ('user', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
        ),
    ]
