from django.shortcuts import render,  redirect
from django.http import HttpResponse
from django.http import HttpResponseRedirect
from django.http import JsonResponse
from django.http import *
from Webcashier.models import *
from django.db.models import Sum, F
from .forms import *
from django.contrib.auth import authenticate, login as authlogin, logout as authlogout
from django.contrib.auth.models import User
from django.views.decorators.csrf import csrf_exempt
from django.contrib.auth.hashers import make_password
import joblib
from django.contrib.auth.decorators import login_required
from django.db.models.signals import post_save
from Webcashier.backEnd import FaceRecognition
from django.contrib import messages
import json
#from   import FaceRecognition

facerecognition = FaceRecognition()


# Create your views here.

def Homepage(request):
    
    return render(request,'Webcashier/Home.html')

def logout(req):
    authlogout(req)
    return redirect('/')


def loginpage(request):
    print(request)
    if request.POST:
        print("request.POST")
        user = authenticate(username=request.POST['username'], password=request.POST['password'])
        print('USER =',user)    
        return redirect('/Home/')
        if user == None:
          auth.login(request, user)
          return redirect('/')
        else:
          return redirect('/')   
                
    else :
        print('เขายังไม่ได้กรอก login/password (ครั้งแรกที่เข้าหน้านี้)')
    return render(request, 'Webcashier/login.html')

def Incustumerpage(request,face_id):
    face_id = int(face_id)
    print(face_id)
    data = {
        'user': UserProfile.objects.get(face_id= face_id)
    }

    return render(request, 'Webcashier/Incustumer.html', data)
     
 

def Editcustumerpage(request, face_id):
    face_id = int(face_id)
    user = Incustumer.objects.get(face_id= face_id)
    if request.POST:
        form = RegisterForm(request.POST or None)
        print(request.POST)
        if form.is_valid():
            instance = form.save(commit=False)
            instance.save()
            return redirect('/Home/Incustumer/'+ str(face_id))
        else:
            messages.error(request, "Account Register Failed!")
    
    form = RegisterForm(user)

    data = {
        'user': user,
        'form':form,
    }
    return render(request,'Webcashier/Editcustumer.html', data)      

def Listpage(request, face_id):
    face_id = int(face_id)
    user = Incustumer.objects.get(face_id= face_id)

    data = {
        'user': user,
        'list': Order.objects.filter(user = user.pk).annotate(total=Sum(F('sum_Order')*F('product__price')))

    }
    return render(request, 'Webcashier/list.html', data)  

def Orderpage(request):
    
    product = Product.objects.all()
    context = {
       
        'product': product
    }
    return render(request, 'Webcashier/Order.html',context)  

def Basepage(request, face_id):
    user = Incustumer.objects.get(face_id = face_id)
    product = Product.objects.all()
    context = {
        'user': user,
        'product': product
    }
    return render(request, 'Webcashier/base.html',context)

def saveOrder(request):
    if request.method == 'GET':
        request_getdata = json.loads(request.GET.get('orderData', None))
        user = Incustumer.objects.get(pk = request_getdata['user'])  
        product = Product.objects.get(pk = request_getdata['product'])  
        emp = User.objects.get()
        order = Order(user= user,product= product,sum_Order= request_getdata['sum_Order'], Emp = emp)
        order.save()
    return JsonResponse({'status': 'done'}) 

def changePoint(request):
    if request.method == 'GET':
        request_getdata = json.loads(request.GET.get('point', None))
        user = Incustumer.objects.get(pk = request_getdata['in_id'])
        user.point = request_getdata['point']
        user.save()
    return JsonResponse({'status': 'done'}) 

def registercus(request):
    if request.POST:
        form = RegisterForm(request.POST or None)
        print(form)
        if form.is_valid():
            instance = form.save(commit=False)
            instance.save()
            messages.success(request, 'Successfully Registerd!')
            addFace(instance.pk, request.POST['card_id'])
            return redirect('/Home/')
        else:
            messages.error(request, "Account Register Failed!")

    form = RegisterForm()
   
    context = {
        'title' : 'Register Form',
        'form' : form,
    }

    return render(request, 'Webcashier/register.html', context  )

def addFace(id, card_id):
    card_id = card_id
    face_id = facerecognition.faceDetect(card_id)
    incustomer = Incustumer.objects.filter(pk = id).update(face_id = face_id)
    return redirect('/')

def loginIncus(request):
    face_id = facerecognition.recognizeFace()
    print(face_id)
    return redirect('/Home/Incustumer/'+ str(face_id))

def welcome(request, face_id):
    face_id = int(face_id)
    user = Incustumer.objects.get(face_id= face_id)

    data = {
        'user': user,
        'list': Order.objects.filter(user = user.pk).annotate(total=Sum(F('sum_Order')*F('product__price')))

    }

    return render(request, 'Webcashier/Incustumer.html', data)
    
